from cpl_query.extension import List

from py_to_uxf_core.model.function_access_modifier_enum import FunctionAccessModifierEnum
from py_to_uxf_core.model.python_function_argument import PythonFunctionArgument


class PythonFunction:

    def __init__(self, access_modifier: FunctionAccessModifierEnum, name: str, args: List[PythonFunctionArgument], return_type: str):
        self._access_modifier = access_modifier
        self._name = name
        self._args = args
        self._return_type = return_type

    @property
    def access_modifier(self):
        return self._access_modifier

    @property
    def name(self) -> str:
        return self._name

    @property
    def args(self) -> List[PythonFunctionArgument]:
        return self._args

    @property
    def return_type(self) -> str:
        return self._return_type
